<template>
  <v-dialog
    v-model="dialog"
    max-width="560"
    scrollable
    @click:outside="onClickOutside"
  >
    <template v-slot:activator="{ props: activatorProps }">
      <slot name="activator" :props="activatorProps">
        <svn-pro-button
          v-bind="activatorProps"
          variant="text"
          color="primary"
          text="Open Dialog"
        >
        </svn-pro-button>
      </slot>
    </template>

    <template v-slot:default="{ isActive }">
      <v-card rounded="xl">
        <template v-if="icon" #prepend>
          <Icon
            width="24"
            height="24"
            :icon="icon"
          />
        </template>

        <template #title>
          <slot name="title">
            <svn-pro-title h6 class="line-clamp-1 break-all">
              {{ title }}
            </svn-pro-title>
          </slot>
        </template>

        <template v-if="subtitle" #subtitle>
          {{ subtitle }}
        </template>

        <v-card-text :style="`height: ${contentHeight}px;`">
          <slot name="text">
            <svn-pro-text bodyMedium>
              {{ contentText }}
            </svn-pro-text>
          </slot>
        </v-card-text>

        <v-card-actions v-if="actionOneTitle || actionTwoTitle">
          <v-spacer></v-spacer>

          <svn-pro-button
            v-if="actionTwoTitle"
            variant="text"
            color="primary"
            :text="actionTwoTitle"
            @click="onClickActionTwo"
          >
          </svn-pro-button>

          <svn-pro-button
            v-if="actionOneTitle"
            variant="text"
            color="primary"
            :text="actionOneTitle"
            @click="onClickActionOne"
          >
          </svn-pro-button>
        </v-card-actions>
      </v-card>
    </template>
  </v-dialog>
</template>

<script setup>
import SvnProTitle from "../styles/SvnProTitle.vue"
import SvnProText from "../styles/SvnProText.vue"
import SvnProButton from "../button/SvnProButton.vue"
import { ref } from "vue";
import { Icon } from "@iconify/vue";

const dialog = ref(false)

const emit = defineEmits(['click-primary-button', 'click-secondary-button', 'click-outside'])

const props = defineProps({
  title: {
    type: String,
    default: "Dialog title",
  },
  contentText: {
    type: String,
    default: undefined,
  },
  subtitle: {
    type: String,
    default: undefined,
  },
  contentHeight: {
    type: Number,
    default: undefined,
  },
  icon: {
    type: String,
    default: undefined,
  },
  actionOneTitle: {
    type: String,
    default: undefined,
  },
  actionTwoTitle: {
    type: String,
    default: undefined,
  },
})

const onClickActionOne = () => {
  emit('click-primary-button')
}

const onClickActionTwo = () => {
  emit('click-secondary-button')
}

const onClickOutside = () => {
  emit("click-outside")
}

defineExpose({
  dialog
})
</script>